Index: pcp/src/wannier.c
===================================================================
--- pcp/src/wannier.c	(revision 9bdd866eca950981175d4eb672952e1c119b1d98)
+++ pcp/src/wannier.c	(revision 4f136930622a3ef24a8e10066443133f1c24c77c)
@@ -256,55 +1142,186 @@
 void ComputeMLWF(struct Problem *P) {
   // variables and allocation
-  struct FileData *F = &P->Files;
   struct Lattice *Lat = &P->Lat;
-  struct RunStruct *R = &P->R;
   struct Psis *Psi = &Lat->Psi;
-  struct LatticeLevel *Lev0 = R->Lev0;
-  struct LatticeLevel *LevS = R->LevS;
-  struct Density *Dens0 = Lev0->Dens;
-  struct fft_plan_3d *plan = Lat->plan; 
-  fftw_complex *PsiC = Dens0->DensityCArray[ActualPsiDensity];
-  fftw_real *PsiCR = (fftw_real *)PsiC;
-  fftw_complex *work = Dens0->DensityCArray[Temp2Density]; 
-  fftw_real **HGcR = &Dens0->DensityArray[HGDensity];  // use HGDensity, 4x Gap..Density, TempDensity as a storage array
-  fftw_complex **HGcRC = (fftw_complex**)HGcR;
-  fftw_complex **HGcR2C = &Dens0->DensityCArray[HGcDensity];  // use HGcDensity, 4x Gap..Density, TempDensity as an array
-  fftw_real **HGcR2 = (fftw_real**)HGcR2C;
-  MPI_Status status;
-  struct OnePsiElement *OnePsiB, *OnePsiA, *LOnePsiB;
-  int ElementSize = (sizeof(fftw_complex) / sizeof(double)), RecvSource;
-  fftw_complex *LPsiDatA=NULL, *LPsiDatB=NULL;
-  int n[NDIM],n0,i0,iS, Index;
-  int N0;
-  int N[NDIM];
-  const int NUpx = LevS->NUp[0];
-  const int NUpy = LevS->NUp[1];
-  const int NUpz = LevS->NUp[2];
-  int e,i,j,k,l,m,u,p,g;
+  int i;
   int Num = Psi->NoOfPsis;  // is number of occupied plus unoccupied states for rows
+  double **WannierCentre;
+  double *WannierSpread;
+  double spread, spreadSQ;
+  struct DiagonalizationData DiagData;
+
+  if(P->Call.out[StepLeaderOut]) fprintf(stderr,"(%i) Beginning localization of orbitals ...\n",P->Par.me);
+
+  InitDiagonalization(P, &DiagData, Num, max_operators, 1);
+
+  // STEP 2: Calculate A[k]_ij = V/N \sum_{G1,G2} C^\ast_{l,G1} c_{m,G2} \sum_R A^{(k)}(R) exp(iR(G2-G1))
+  //debug (P,"Calculatung Variance matrices");
+  FillHigherOrderRealMomentsMatrices(P, DiagData.AllocNum, DiagData.A);
+
+  //debug (P,"Diagonalizing");
+  Diagonalize(P, &DiagData);
+
+  // STEP 6: apply transformation U to all wave functions \sum_i^Num U_ji | \phi_i \rangle = | \phi_j^\ast \rangle
+  //debug (P,"Performing Unitary transformation");
+  UnitaryTransformationOnWavefunctions(P, DiagData.U, Num);
+
+  if(P->Call.out[ReadOut]) fprintf(stderr,"(%i) STEP 7: Compute centres and spread printout\n",P->Par.me);
+  WannierCentre = (double **) Malloc(sizeof(double *)*Num, "ComputeMLWF: *WannierCentre");
+  WannierSpread = (double *) Malloc(sizeof(double)*Num, "ComputeMLWF: WannierSpread"); 
+  for (i=0;i<Num;i++)
+    WannierCentre[i] = (double *) Malloc(sizeof(double)*NDIM, "ComputeMLWF: WannierCentre");
+
+  //debug (P,"Computing Wannier centres from variance matrix"); 
+  ComputeWannierCentresfromVarianceMatrices(P, DiagData.A, &spread, &spreadSQ, WannierCentre, WannierSpread);
+
+  // join Wannier orbital to groups with common centres under certain conditions
+  //debug (P,"Changing Wannier Centres according to CommonWannier");
+  ChangeWannierCentres(P, Num, WannierCentre, WannierSpread); 
+  
+  // write to file
+  //debug (P,"Writing spread file");
+  WriteWannierFile(P, spread, spreadSQ, WannierCentre, WannierSpread);  
+
+  debug(P,"Free'ing memory");
+  // free all remaining memory
+  FreeDiagonalization(&DiagData);
+  for (i=0;i<Num;i++)
+    Free(WannierCentre[i], "ComputeMLWF: WannierCentre[i]");
+  Free(WannierCentre, "ComputeMLWF: WannierCentre");
+  Free(WannierSpread, "ComputeMLWF: WannierSpread");
+}
+
+/** Solves directly for eigenvectors and eigenvalues of a real 2x2 matrix.
+ * The eigenvalues are determined by \f$\det{(A-\lambda \cdot I)}\f$, where \f$I\f$ is the unit matrix and
+ * \f$\lambda\f$ an eigenvalue. This leads to a pq-formula which is easily evaluated in the first part.
+ * 
+ * The eigenvectors are then obtained by solving \f$A-\lambda \cdot I)x = 0\f$ for a given eigenvalue
+ * \f$\lambda\f$. However, the eigenvector magnitudes are not specified, thus we the equation system is
+ * still lacking such an equation. We use this fact to set either coordinate arbitrarily to 1 and then
+ * derive the other by solving the equation system. Finally, the eigenvector is normalized.  
+ * \param *P Problem at hand
+ * \param *A matrix whose eigenvalues/-vectors are to be found
+ * \param *eval vector with eigenvalues
+ * \param *evec matrix with corresponding eigenvectors in columns
+ */
+#ifdef HAVE_INLINE 
+inline void EigensolverFor22Matrix(struct Problem *P, gsl_matrix *A, gsl_vector *eval, gsl_matrix *evec)
+#else
+void EigensolverFor22Matrix(struct Problem *P, gsl_matrix *A, gsl_vector *eval, gsl_matrix *evec)
+#endif
+{
+  double a11,a12,a21,a22;
+  double ev[2], summand1, summand2, norm;
+  int i;
+  // find eigenvalues
+  a11 = gsl_matrix_get(A,0,0);
+  a12 = gsl_matrix_get(A,0,1);
+  a21 = gsl_matrix_get(A,1,0);
+  a22 = gsl_matrix_get(A,1,1);
+  summand1 = (a11+a22)/2.;
+  summand2 = sqrt(summand1*summand1 + a12*a21 - a11*a22);
+  ev[0] = summand1 + summand2;
+  ev[1] = summand1 - summand2;
+  gsl_vector_set(eval, 0, ev[0]);
+  gsl_vector_set(eval, 1, ev[1]);
+  //fprintf (stderr,"(%i) ev1 %lg \t ev2 %lg\n", P->Par.me, ev1, ev2);
+  
+  // find eigenvectors
+  for(i=0;i<2;i++) {
+    if (fabs(ev[i]) < MYEPSILON) {
+      gsl_matrix_set(evec, 0,i, 0.);
+      gsl_matrix_set(evec, 1,i, 0.);
+    } else if (fabs(a22-ev[i]) > MYEPSILON) {
+      norm = sqrt(1*1 + (a21*a21/(a22-ev[i])/(a22-ev[i])));
+      gsl_matrix_set(evec, 0,i, 1./norm);
+      gsl_matrix_set(evec, 1,i, -(a21/(a22-ev[i]))/norm);
+      //fprintf (stderr,"(%i) evec %i (%lg,%lg)", P->Par.me, i, -(a12/(a11-ev[i]))/norm, 1./norm);
+    } else if (fabs(a12) > MYEPSILON) {
+      norm = sqrt(1*1 + (a11-ev[i])*(a11-ev[i])/(a12*a12));
+      gsl_matrix_set(evec, 0,i, 1./norm);
+      gsl_matrix_set(evec, 1,i, -((a11-ev[i])/a12)/norm);
+      //fprintf (stderr,"(%i) evec %i (%lg,%lg)", P->Par.me, i, -(a12/(a11-ev[i]))/norm, 1./norm);
+    } else {
+      if (fabs(a11-ev[i]) > MYEPSILON) {
+        norm = sqrt(1*1 + (a12*a12/(a11-ev[i])/(a11-ev[i])));
+        gsl_matrix_set(evec, 0,i, -(a12/(a11-ev[i]))/norm);
+        gsl_matrix_set(evec, 1,i, 1./norm);
+        //fprintf (stderr,"\t evec %i (%lg,%lg)\n", i, -(a12/(a11-ev[i]))/norm, 1./norm);
+      } else if (fabs(a21) > MYEPSILON) {
+        norm = sqrt(1*1 + (a22-ev[i])*(a22-ev[i])/(a21*a21));
+        gsl_matrix_set(evec, 0,i, -(a22-ev[i])/a21/norm);
+        gsl_matrix_set(evec, 1,i, 1./norm);
+        //fprintf (stderr,"\t evec %i (%lg,%lg)\n", i, -(a12/(a11-ev[i]))/norm, 1./norm);
+      } else {
+        //gsl_matrix_set(evec, 0,i, 0.);
+        //gsl_matrix_set(evec, 1,i, 1.);
+        fprintf (stderr,"\t evec %i undetermined\n", i);
+      }
+      //gsl_matrix_set(evec, 0,0, 1.);
+      //gsl_matrix_set(evec, 1,0, 0.);
+      //fprintf (stderr,"(%i) evec1 undetermined", P->Par.me);
+    }
+  }
+}
+
+/** Calculates sine and cosine values for multiple matrix diagonalization.
+ * \param *evec eigenvectors in columns
+ * \param *eval corresponding eigenvalues
+ * \param *c cosine to be returned
+ * \param *s sine to be returned
+ */
+#ifdef HAVE_INLINE
+inline void CalculateRotationAnglesFromEigenvalues(gsl_matrix *evec, gsl_vector *eval, double *c, double *s)
+#else
+void CalculateRotationAnglesFromEigenvalues(gsl_matrix *evec, gsl_vector *eval, double *c, double *s)
+#endif
+{
+  int index;
   double x,y,r;
-  double q[NDIM];
-  double *c,*s;
-  int index;
-  double spread = 0., old_spread=0., Spread=0.;
-  double WannierCentre[Num][NDIM];
-  double WannierSpread[Num];
-  double tmp,tmp2;
-  double a_ij = 0, b_ij = 0, A_ij = 0, B_ij = 0;
-  double **cos_lookup,**sin_lookup; 
-  gsl_matrix *G;
-  gsl_vector *h;
-  gsl_vector *eval;
-  gsl_matrix *evec;
-  gsl_eigen_symmv_workspace *w;
-  int ProcNum, ProcRank, set;
-  int it_steps; // iteration step counter
-  int *top, *bot;
-  int Lsend, Rsend, Lrecv, Rrecv; // where left(right) column is sent to or where it originates from
-  int left, right; // left or right neighbour for process
-  double **Aloc[max_operators+1], **Uloc; // local columns for one step of A[k]
-  double *Around[max_operators+1], *Uround; // all local columns for one round of A[k]
-  double *Atotal[max_operators+1], *Utotal; // all local columns for one round of A[k]
-  double a_i, a_j;
+  
+  index = gsl_vector_max_index (eval);  // get biggest eigenvalue
+  //fprintf(stderr,"\t1st: %lg\t2nd: %lg ---  biggest: %i\n", gsl_vector_get(eval, 0), gsl_vector_get(eval, 1), index);
+  x = gsl_matrix_get(evec, 0, index);
+  y = gsl_matrix_get(evec, 1, index);
+  if (x < 0) {  // ensure x>=0 so that rotation angles remain smaller Pi/4
+    y = -y;
+    x = -x;  
+  }
+  //z = gsl_matrix_get(evec, 2, index) * x/fabs(x);
+  //fprintf(stderr,"\tx %lg\ty %lg\n", x,y);
+  
+  //fprintf(stderr,"(%i),(%i,%i) STEP 3c\n",P->Par.me,i,j);
+  // STEP 3c: calculate R = [[c,s^\ast],[-s,c^\ast]]
+  r = sqrt(x*x + y*y); // + z*z);
+  if (fabs(r) > MYEPSILON) {
+    *c = sqrt((x + r) / (2.*r));
+    *s = y / sqrt(2.*r*(x+r)); //, -z / sqrt(2*r*(x+r)));
+  } else {
+    *c = 1.;
+    *s = 0.;
+  }
+}
+
+/*
+ * \param **A matrices (pointer array with \a NumMatrices entries) to be diagonalized
+ * \param *U transformation matrix set to unity matrix
+ * \param NumMatrices number of matrices to be diagonalized simultaneously
+ * \param extra number of additional matrices the rotation is applied to however which actively diagonalized (follow in \a **A)
+ * \param AllocNum number of rows/columns in matrices
+ * \param Num number of wave functions
+ * \param ProcRank index in group for this cpu
+ * \param ProcNum number of cpus in group
+ * \param *top array with top row indices (merry-go-round)
+ * \param *bot array with bottom row indices (merry-go-round) 
+ */
+
+/** Simultaneous diagonalization of matrices with multiple cpus.
+ * \param *P Problem at hand
+ * \param *DiagData pointer to structure DiagonalizationData containing necessary information for diagonalization
+ * \note this is slower given one cpu only than SerialDiagonalization()
+ */
+void ParallelDiagonalization(struct Problem *P, struct DiagonalizationData *DiagData)
+{
+  struct RunStruct *R =&P->R;
   int tagR0, tagR1, tagS0, tagS1;
   int iloc, jloc;
